%define __libtoolize :
%global momorel 1

Summary: A GNU source-level debugger for C, C++ and Fortran.
Name: gdb
Version: 6.3
Release: %{momorel}m
License: GPL
Group: Development/Debuggers
URL: http://www.gnu.org/directory/gdb.html
%NoSource 0 ftp://ftp.gnu.org/gnu/gdb/gdb-%{version}.tar.bz2 05b928f41fa5b482e49ca2c24762a0ae
BuildRoot: %{_tmppath}/%{name}-%{version}-root

# For our convenience
%define gdb_src gdb-6.3
%define gdb_build gdb-%{version}-build-%{_target_platform}

# GDB patches have the format gdb-<version>-<desc>-<YYYYMMDD>.patch;
# should include the ChangeLog.RedHat change-log entry; and should be
# created using diff -u ./gdb (not gdb-6.3/gdb).

# Red Hat local patches

Patch0: gdb-6.3-rh-changelogs-20041202.patch

# Work around out-of-date dejagnu that does not have KFAIL
Patch1: gdb-6.3-rh-dummykfail-20041202.patch

# Match Red Hat's version info
Patch2: gdb-6.3-rh-testversion-20041202.patch

# Check that libunwind works - new test then fix
Patch3: gdb-6.3-rh-testlibunwind-20041202.patch
Patch4: gdb-6.3-rh-testlibunwind1fix-20041202.patch


# ------------------------------------------

# Add fixes starting at 100

# Just issue a warning when DW_OP_piece.  Stops GDB falling on the
# floor.
Patch100: gdb-6.3-dwoppiecewarning-20041202.patch

# Recognize i386 signal trampolines before CFI.  Ensures that signal
# frames are identified as signal frames.
Patch101: gdb-6.3-sigx86-20040621.patch

# Don't reject signal trampoline frames that have a [data] symbol
# associated with them as occures when backtracing through an
# alt-stack in the data address space.
Patch102: gdb-6.3-sigsymtramp-20040621.patch

# Add unwinders for PPC and PPC64 signal trampolines.
Patch103: gdb-6.3-ppcsignals-20040621.patch

# Use convert_from_func_ptr_addr on the solib breakpoint address;
# simplifies and makes more consistent the logic.
Patch104: gdb-6.3-ppcdotsolib-20041022.patch

# Better parse 64-bit PPC system call prologues.
Patch105: gdb-6.3-ppc64syscall-20040622.patch

# Stop a backtrace when a zero PC is encountered.
Patch106: gdb-6.3-framepczero-20040927.patch

# Hack around broken header files that incorrectly define the FPSCR
# macro.
Patch107: gdb-6.3-ppc64fpscrhack-20041026.patch

# Pass the pc's section into the symbol search code; stops the lookup
# finding a symbol from the wrong section.
Patch108: gdb-6.3-ppc64section-20041026.patch

# Add PPC register groups so that info registers et.al.; along with
# register save and restore; work better.  On PPC-64 it was restoring
# the PS register setting the break-on-branch bit!
Patch109: gdb-6.3-ppcreggroups-20041124.patch

# Fix up 64-bit PPC inferior function calls so that function
# parameters are passed correctly.
Patch110: gdb-6.3-ppc64abi-20040621.patch

# Include the pc's section when doing a symbol lookup so that the
# correct symbol is found.
Patch111: gdb-6.3-ppc64displaysymbol-20041124.patch

# Fix stepping in threads
Patch112: gdb-6.3-thread-step-20041207.patch

# Threaded watchpoint support
Patch113: gdb-6.3-threaded-watchpoints-20041213.patch

# Multiple patches to ia64 backtrace
Patch114: gdb-6.3-ia64-backtrace-20041213.patch

# Fix to expose multiple constructors to end-user
Patch115: gdb-6.3-constructor-20041216.patch

# Fix to display base constructors from list and breakpoint commands
Patch116: gdb-6.3-linespec-20041213.patch

# Continue removing breakpoints even when failure occurs.
Patch117: gdb-6.3-removebp-20041130.patch

# Add a wrapper script to GDB that implements pstack using the
# --readnever option.
Patch118: gdb-6.3-gstack-20041123.patch

# Fix for caching thread lwps for linux
Patch119: gdb-6.3-lwp-cache-20041216.patch

# Fix to ensure types are visible
Patch120: gdb-6.3-type-fix-20041213.patch

# Fix for allowing macros to continue after backtrace errors
Patch121: gdb-6.3-backtrace-20041216.patch

# VSYSCALL and PIE
Patch122: gdb-6.3-test-pie-20050107.patch
Patch123: gdb-6.3-vsyscall-20041216.patch
Patch124: gdb-6.3-pie-20050110.patch

# Get selftest working with sep-debug-info
Patch125: gdb-6.3-test-self-20050110.patch

# No longer a need to set .malloc on ppc64.
Patch126: gdb-6.3-ppcmalloc-20041124.patch

# Enable PPC CFI support.
Patch127: gdb-6.3-ppccfi-20041104.patch

# Fix for non-threaded watchpoints.
Patch128: gdb-6.3-nonthreaded-wp-20050117.patch

# Add synthetic symbols (esp PPC-64 .symbols) to min symtab
Patch129: gdb-6.3-ppcdotsym-20050126.patch

# Add PPC .symbols to min-symtable.
Patch130: gdb-6.3-ctorline-20050120.patch

# Handle nested, and back-to-back signals when stepping.
Patch131: gdb-6.3-sigrepeats-20050121.patch
Patch132: gdb-6.3-test-sigrepeats-20050121.patch

# Fix to support multiple destructors just like multiple constructors
Patch133: gdb-6.3-test-dtorfix-20050121.patch
Patch134: gdb-6.3-dtorfix-20050121.patch

# Fix for ia64 to prevent SIGSEGV in debugger
Patch135: gdb-6.3-ia64fix-20050121.patch

# Fix to support executable moving
Patch136: gdb-6.3-test-movedir-20050125.patch
Patch137: gdb-6.3-movedir-20050125.patch

# Fix to support unwinding syscalls in ia64 corefiles
Patch138: gdb-6.3-ia64-corefile-fix-20050127.patch

# Tolerate DW_AT_type referencing <0>.
Patch139: gdb-6.3-dwattype0-20050201.patch

# Fix gcore for threads
Patch140: gdb-6.3-gcore-thread-20050204.patch

%ifarch ia64
BuildRequires: ncurses-devel glibc-devel gcc make gzip texinfo dejagnu libunwind >= 0.96-3
%else
BuildRequires: ncurses-devel glibc-devel gcc make gzip texinfo dejagnu
%endif

%ifarch ia64
Requires: libunwind >= 0.96-3
%endif
 
Prereq: info

%description
GDB, the GNU debugger, allows you to debug programs written in C, C++,
Java, and other languages, by executing them in a controlled fashion
and printing their data.

%prep

# This allows the tarball name to be different from our
# version-release name.

%setup -q -n %{gdb_src}

# Apply patches defined above.

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%patch121 -p1
%patch122 -p1
%patch123 -p1
%patch124 -p1
%patch125 -p1
%patch126 -p1
%patch127 -p1
%patch128 -p1
%patch129 -p1
%patch130 -p1
%patch131 -p1
%patch132 -p1
%patch133 -p1
%patch134 -p1
%patch135 -p1
%patch136 -p1
%patch137 -p1
%patch138 -p1
%patch139 -p1
%patch140 -p1

# Change the version that gets printed at GDB startup, so it is RedHat
# specific.
cat > gdb/version.in << _FOO
Red Hat Linux (%{version}-%{release}rh)
_FOO

# Remove the info and other generated files added by the FSF release
# process.
rm -f gdb/doc/*.info
rm -f gdb/doc/*.info-*

# ... and remove the objective-c testcases -- no objective-c
rm -fr gdb/testsuite/gdb.objc                                                                                
# ... and remove the ada testcases -- no ada support at all.
rm -fr gdb/testsuite/gdb.ada                                                                                
# FIXME: remove gdb/gdbserver/config.h from the snapshot. Suspect a bug
# in the FSF snapshot process.
rm -f gdb/gdbserver/config.h

%build

# Initially we're in the %{gdb_src} directory.
cd ..

# Identify the build directory with the version of gdb as well as the
# architecture, to allow for mutliple versions to be installed and
# built.

rm -fr %{gdb_build}
mkdir %{gdb_build}
cd %{gdb_build}

# FIXME: The configure option --enable-gdb-build-warnings=,-Werror
# below can conflict with user settings. For instance, passing a
# combination of -Wall and -O0 from the file rpmrc will always cause
# at least one warning, and stop the compilation.  The whole configury
# line needs to be cleaned up.

export CFLAGS="$RPM_OPT_FLAGS"

enable_build_warnings=""
%ifarch %{ix86} alpha ia64 ppc s390 s390x x86_64 ppc64
enable_build_warnings="--enable-gdb-build-warnings=,-Werror"
%endif

../%{gdb_src}/configure \
	--prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir} \
	--mandir=%{_mandir} \
	--infodir=%{_infodir}\
	$enable_build_warnings \
        --with-separate-debug-dir=/usr/lib/debug \
    %{_target_platform}

make
make info

# Get some information about which tools we interact with. We cannot
# invoke rpm -q from here.
# Note that binutils and glibc don't brand themselves as RedHat specific
# versions. This is very wrong. They are not the vanilla FSF ones!
%ifarch %{ix86} ppc s390 ia64
if [ -x /lib/tls/libc.so.6 ] ; then
  /lib/tls/libc.so.6
elif [ -x /lib/tls/libc.so.6.1 ] ; then
    /lib/tls/libc.so.6.1
fi
%endif
%ifarch x86_64 s390x ppc64
if  [ -x /lib64/tls/libc.so.6 ] ; then
   /lib64/tls/libc.so.6
fi
%endif

gcc -v
uname -a
ld -v

# For now do testing only on these platforms. 
%ifarch %{ix86} x86_64 s390x s390 ppc ia64 ppc64
echo ====================TESTING=========================
cd gdb/testsuite
# Need to use a single --ignore option, second use overrides first.
make -k check RUNTESTFLAGS='--ignore bigcore.exp\ attach-pie.exp\ asm-source.exp\ sigstep.exp' || :
for t in sum log; do
  ln gdb.$t gdb-%{_target_platform}.$t || :
done
tar cf - gdb-%{_target_platform}.{sum,log} \
	| bzip2 -1 \
	| uuencode gdb-%{_target_platform}.tar.bz2 \
	|| :
cd ../..
echo ====================TESTING END=====================
%endif

cd ..
# Copy the <sourcetree>/gdb/NEWS file to the directory above it.
cp $RPM_BUILD_DIR/%{gdb_src}/gdb/NEWS $RPM_BUILD_DIR/%{gdb_src}

%install
cd ../%{gdb_build}
rm -rf %{buildroot}

%makeinstall

# install the gcore script in /usr/bin
cp $RPM_BUILD_DIR/%{gdb_src}/gdb/gdb_gcore.sh %{buildroot}%{_prefix}/bin/gcore
chmod 755 %{buildroot}%{_prefix}/bin/gcore

# Remove the files that are part of a gdb build but that are owned and
# provided by other packages.
# These are part of binutils

rm -rf %{buildroot}/usr/share/locale/
rm -f %{buildroot}%{_infodir}/bfd* 
rm -f %{buildroot}%{_infodir}/standard*
rm -f %{buildroot}%{_infodir}/mmalloc*
rm -f %{buildroot}%{_infodir}/configure*
rm -rf %{buildroot}/usr/include/  
rm -rf %{buildroot}/%{_libdir}/lib{bfd*,opcodes*,iberty*,mmalloc*}

# Delete this too because the dir file will be updated at rpm install time.
# We don't want a gdb specific one overwriting the system wide one.

rm -f %{buildroot}%{_infodir}/dir

%clean
rm -rf %{buildroot}

%post
# This step is part of the installation of the RPM. Not to be confused
# with the 'make install ' of the build (rpmbuild) process.

[ -f %{_infodir}/annotate.info ]	&& /sbin/install-info %{_infodir}/annotate.info %{_infodir}/dir || :
[ -f %{_infodir}/annotate.info.gz ]	&& /sbin/install-info %{_infodir}/annotate.info.gz %{_infodir}/dir  || :
[ -f %{_infodir}/gdb.info ]		&& /sbin/install-info %{_infodir}/gdb.info %{_infodir}/dir || :
[ -f %{_infodir}/gdb.info.gz ]		&& /sbin/install-info %{_infodir}/gdb.info.gz %{_infodir}/dir  || :
[ -f %{_infodir}/gdbint.info ]         && /sbin/install-info %{_infodir}/gdbint.info %{_infodir}/dir || :
[ -f %{_infodir}/gdbint.info.gz ]      && /sbin/install-info %{_infodir}/gdbint.info.gz %{_infodir}/dir  || :
[ -f %{_infodir}/stabs.info ]		&& /sbin/install-info %{_infodir}/stabs.info %{_infodir}/dir  || :
[ -f %{_infodir}/stabs.info.gz ]	&& /sbin/install-info %{_infodir}/stabs.info.gz %{_infodir}/dir  || :

%preun
if [ $1 = 0 ]; then
	[ -f %{_infodir}/annotate.info ]	&& /sbin/install-info --delete %{_infodir}/annotate.info %{_infodir}/dir  || :
	[ -f %{_infodir}/annotate.info.gz ]	&& /sbin/install-info --delete %{_infodir}/annotate.info.gz %{_infodir}/dir  || :
	[ -f %{_infodir}/gdb.info ]		&& /sbin/install-info --delete %{_infodir}/gdb.info %{_infodir}/dir  || :
	[ -f %{_infodir}/gdb.info.gz ]		&& /sbin/install-info --delete %{_infodir}/gdb.info.gz %{_infodir}/dir  || :
	[ -f %{_infodir}/gdbint.info ]          && /sbin/install-info --delete %{_infodir}/gdbint.info %{_infodir}/dir  || :
	[ -f %{_infodir}/gdbint.info.gz ]       && /sbin/install-info --delete %{_infodir}/gdbint.info.gz %{_infodir}/dir  || :
	[ -f %{_infodir}/stabs.info ]		&& /sbin/install-info --delete %{_infodir}/stabs.info %{_infodir}/dir  || :
	[ -f %{_infodir}/stabs.info.gz ]	&& /sbin/install-info --delete %{_infodir}/stabs.info.gz %{_infodir}/dir  || :
fi

%files
%defattr(-,root,root)
%doc COPYING COPYING.LIB README NEWS
/usr/bin/*
%{_mandir}/*/*
%{_infodir}/annotate.info*
%{_infodir}/gdb.info*
%{_infodir}/gdbint.info*
%{_infodir}/stabs.info*

# don't include the files in include, they are part of binutils

%changelog
* Tue Feb 15 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (6.3-1m)
- update 6.3 and import from FC

* Fri Feb  4 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (6.0-2m)
- enable x86_64.

* Mon Mar 29 2004 Toru Hoshina <t@momonga-linux.org>
- (6.0-2m)
- /usr/share/info/annotate.info is missed.

* Mon Mar 22 2004 Toru Hoshina <t@momonga-linux.org>
- (6.0-1m)
- version up. this is expected for kernel 2.6 era, probably.
- dejagnu is also imported, evaluation is needed from now on.

* Sat Mar 20 2004 Toru Hoshina <t@momonga-linux.org>
- (5.3-2m)
- revised spec for enabling rpm 4.2.

* Fri Feb  7 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (5.3-1m)
  update to 5.3

* Mon Jul 29 2002 Tsutomu Yasuda <tom@tom.homelinux.org>
- (5.2.1-1m)
  update to 5.2.1

* Tue Apr 30 2002 Kenta MURATA <muraken@kondara.org>
- (5.1.1-4k)
- /sbin/install-info -> info in PreReq.

* Thu Feb 14 2002 Tsutomu Yasuda <tom@kondara.org>
- (5.1.1-2k)
- fix URL
  update to 5.1.1

* Fri Oct 12 2001 Masaru Sato <masachan@kondara.org>
- add URL tag

* Mon Aug 27 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (5.0-22k)
- removed alpha.patch for building

* Sun Aug 26 2001 Shingo Akagaki <dora@kondara.org>
- release version tar ball

* Sun Mar 18 2001 Toru Hoshina <toru@df-usa.com>
- new snapshot

* Sat Feb 04 2001 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (5.0-15k)
- update source to gdb-20010119.tar.bz2
- Delete gdb-5.0-alpha.patch and gdb-5.0-sparc.patch.
  They have been already included in source.
- don't Exclude sparc

* Thu Nov 09 2000 Kenichi Matsubara <m@kondara.org>
- [5.0-10k]
- bugfix %post.

* Wed Oct 25 2000 MATSUDA, Daiki <dyky@df-usa.com>
- modifiled %post and %preun section from .gz to .bz2

* Tue Aug 08 2000 Toru Hoshina <t@kondara.org>
- rebuild against glibc-2.1.90, X-4.0, rpm-3.0.5.

* Mon Jul 25 2000 Trond Eivind Glomsr?<teg@redhat.com>
- upgrade to CVS snapshot
- excludearch SPARC, build on IA61

* Wed Jul 19 2000 Trond Eivind Glomsr?<teg@redhat.com>
- rebuild

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sun Jul 02 2000 Trond Eivind Glomsr?<teg@redhat.com>
- rebuild

* Fri Jun 08 2000 Trond Eivind Glomsr?<teg@redhat.com>
- use %%configure, %%makeinstall, %%{_infodir}, %%{_mandir},
  and %%{_tmppath}
- the install scripts  for info are broken(they don't care about
  you specify in the installstep), work around that.
- don't build for IA64

* Mon May 22 2000 Trond Eivind Glomsr?<teg@redhat.com>
- upgraded to 5.0 - dump all patches. Reapply later if needed.
- added the NEWS file to the %%doc files
- don't delete files which doesn't get installed (readline, texinfo)
- let build system handle stripping and gzipping
- don't delete libmmalloc
- apply patch from jakub@redhat.com to make it build on SPARC

* Sun May 20 2000 Takaaki Tabuchi <tab@kondara.org>
- update 5.0.

* Fri Apr 28 2000 Matt Wilson <msw@redhat.com>
- rebuilt against new ncurses

* Sun Apr 02 2000 Takaaki Tabuchi <tab@kondara.org>
- merge redhat-6.2 (4.18-11).

* Tue Mar  7 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for sparc baud rates > 38400.

* Wed Mar 1 2000 Masako Hattori <maru@kondara.org>
- change jman mv->cp

* Wed Feb 23 2000 Masako Hattori <maru@kondara.org>
- do not shake %{_mandir}/ja

* Tue Feb  8 2000 Jakub Jelinek <jakub@redhat.com>
- fix core file handling on i386 with glibc 2.1.3 headers

* Fri Jan 14 2000 Jakub Jelinek <jakub@redhat.com>
- fix reading registers from core on sparc.
- hack around build problems on i386 with glibc 2.1.3 headers

* Thu Oct 7 1999 Jim Kingdon
- List files to install in %{_infodir} specifically (so we don't pick up
things like info.info from GDB snapshots).

* Thu Oct 7 1999 Jim Kingdon
- Update GDB to 19991004 snapshot.  This eliminates the need for the
sigtramp, sparc, xref, and threads patches.  Update sparcmin patch.

* Mon Aug 23 1999 Jim Kingdon
- Omit readline manpage.

* Tue Aug 7 1999 Jim Kingdon
- Remove H.J. Lu's patches (they had been commented out).
- Add sigtramp patch (from gdb.cygnus.com) and threads patch (adapted
from code fusion CD-ROM).

* Wed Apr 14 1999 Jeff Johnson <jbj@redhat.com>
- merge H.J. Lu's patches into 4.18.

* Mon Apr 05 1999 Cristian Gafton <gafton@redhat.com>
- updated the kern22 patch with stuff from davem

* Thu Apr  1 1999 Jeff Johnson <jbj@redhat.com>
- sparc with 2.2 kernels no longer uses sunos ptrace (davem)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 3)

* Mon Mar  8 1999 Jeff Johnson <jbj@redhat.com>
- Sparc fiddles for Red Hat 6.0.
